import 'package:flutter/material.dart';
import 'package:midtrans_helper/data/bank.dart';
import 'package:midtrans_helper/data/cardless.dart';
import 'package:midtrans_helper/data/convenience_store.dart';
import 'package:midtrans_helper/data/direct_debit.dart';

Map<String,dynamic> _data = {};

class MidtransView extends StatefulWidget{
  final onnext;

  MidtransView({this.onnext});

  getDataSelected(){
    return _data;
  }
  @override
  _MidtransView createState() => _MidtransView();
}

class _MidtransView extends State<MidtransView>{
  String _selectedMethod; 
  List _listMethod;

  initMethod()
  {
    _listMethod = [];
    
    // card list
    // _listMethod.add({'name' : 'CARD', 'type' : 'child' , 'detail' : []});
    // _listMethod.where((val)=> val['name'] == 'CARD').map((e){
    //   for(var i in card){
    //     e['detail'].add(i);
    //   }
    // }).toList();

    // bank list
    _listMethod.add({'name' : 'ATM/BANK TRANSFER' , 'type' : 'parents' , 'detail' : []});
    _listMethod.where((val)=> val['name'] == 'ATM/BANK TRANSFER').map((e){
      for(var i in bank){
        e['detail'].add(i);
      }
    }).toList();

    // direct debit list
    for(var i in directDebit){
      _listMethod.add({'name' : i['name'], 'type' : 'child' , 'id' : i['id'] , 'image' : i['image'] , 'selected' : false});
    }

    // // convenience store list
    for(var i in convenienceStore){
      _listMethod.add({'name' : i['name'], 'type' : 'child' , 'id' : i['id'] , 'image' : i['image'] , 'selected' : false});
    }

    // // cardless credit list
    for(var i in cardless){
      _listMethod.add({'name' : i['name'], 'type' : 'child' , 'id' : i['id'] , 'image' : i['image'] , 'selected' : false});
    }
    setState((){});
  }

  @override
  void initState() { 
    super.initState();
    initMethod();
    _data = {};
    _selectedMethod = null;
  }
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: SafeArea(
        child: SingleChildScrollView(
          // padding: EdgeInsets.all(16),
          child: Column(
            children: [
              Divider(
                color: Colors.black.withOpacity(0.2),
                height: 0,
              ),

              Column(
                children: _listMethod.map<Widget>((val) {
                  if(val['type'] == 'child'){
                    return Column(
                      children: [
                        ListTile(
                          contentPadding: EdgeInsets.symmetric(horizontal:16,vertical:16),
                          trailing: val['selected'] == true ? Icon(Icons.check,color:Colors.green) : SizedBox(),
                          title: Row(
                            children: [
                              Image.asset(val['image'],width:70),
                              SizedBox(width:20),
                              Text(val['name'],
                                style: TextStyle(
                                  fontWeight: FontWeight.w500,
                                  fontFamily: 'Hind',
                                  fontSize: 16,
                                  color: Colors.black87
                                ),
                              ),
                            ],
                          ),
                          onTap: (){
                            _listMethod.map((val){
                              if(val['type'] == 'parents'){
                                val['detail'].where((vals) => vals['selected'] == true).map((vals) => vals['selected'] = false).toList();
                              }else{
                                val['selected'] = false;
                              }
                            }).toList();
                            
                            val['selected'] = true;
                            _selectedMethod = val['id'];
                            _data = val;
                            setState((){});
                          },
                        ),

                        Divider(
                          color: Colors.black.withOpacity(0.2),
                          height: 0,
                        ),
                      ],
                    );
                  }
                  List detail = val['detail'];
                  return Column(
                    children: [
                      ExpansionTile(
                        title: Padding(
                          padding: EdgeInsets.symmetric(horizontal:8,vertical:16),
                          child: Text(val['name'],
                            style: TextStyle(
                              fontWeight: FontWeight.w500,
                              fontFamily: 'Hind',
                              fontSize: 16,
                              color: Colors.black87
                            ),
                          ),
                        ),
                        children: detail.map<Widget>((valdetail) => 
                          Column(
                            children: [
                              ListTile(
                                contentPadding: EdgeInsets.symmetric(horizontal:16,vertical:16),
                                tileColor: Colors.black.withOpacity(0.02),
                                trailing: valdetail['selected'] == true ? Icon(Icons.check,color:Colors.green) : SizedBox(),
                                title: Row(
                                  children: [
                                    Image.asset(valdetail['image'],width:70),
                                    SizedBox(width:20),
                                    Text(valdetail['name'],
                                      style: TextStyle(
                                        fontWeight: FontWeight.w500,
                                        fontFamily: 'Hind',
                                        fontSize: 16,
                                        color: Colors.black87
                                      ),
                                    ),
                                  ],
                                ),
                                onTap: (){
                                  _listMethod.map((val){
                                    if(val['type'] == 'parents'){
                                      val['detail'].where((vals) => vals['selected'] == true).map((vals) => vals['selected'] = false).toList();
                                    }else{
                                      val['selected'] = false;
                                    }
                                  }).toList();
                                  valdetail['selected'] = true;
                                  _selectedMethod = valdetail['id'];
                                  _data = valdetail;
                                  setState((){});
                                },
                              ),
                              Divider(
                                color: Colors.black.withOpacity(0.2),
                                height: 0,
                              ),
                            ],
                          ),
                        ).toList()
                      ),

                      Divider(
                        color: Colors.black.withOpacity(0.2),
                        height: 0,
                      ),
                    ],
                  );
                }).toList()
              )
            ],
          )
        ),
      ),
      bottomNavigationBar: Material(
        elevation: 5.0,
        borderRadius: BorderRadius.circular(3.0),
        child: MaterialButton(
          color: Colors.blue,
          minWidth: MediaQuery.of(context).size.width,
          padding: EdgeInsets.fromLTRB(20.0, 15.0, 20.0, 15.0),
          onPressed: widget.onnext,
          child: Row(
            mainAxisAlignment: MainAxisAlignment.center,
            children: [
              Text(_selectedMethod == null ? "SELECT METHOD" : "NEXT STEP",
                textAlign: TextAlign.center,
                style: TextStyle(
                  fontWeight: FontWeight.w500,
                  fontFamily: 'Hind',
                  fontSize: 16,
                  color: Colors.white
                ),
              ),

              _selectedMethod == null ? SizedBox() : Icon(Icons.keyboard_arrow_right, color: Colors.white),
            ],
          )
        ),
      ),
    );
  }
}